/*
 * C Program to Segregate 0s on Left Side & 1s on right side of the Array (Traverse Array only once)
 */
#define SIZE
 
/*Function to segregate all 0s on left and all 1s on right*/
void segregate0and1(bool array[], int size)
{
    int left = 0;
    int right = size-1;
 
    while (left < right)
    {
        /* Increment left index while we see 0 at left */
        while ( array[left] == false && left < right )
            left++;
        /* Decrement right index while we see 1 at right */
        while ( array[right] == true && left < right )
            right--;
        /* If left is smaller than right then there is a 1 at left and a 0 at right.  Exchange it */
        if (left < right)
        {
            array[left] = false;
            array[right] = true;
            left++;
            right--;
        }
    }
}
 
int main()
{
    bool arr[SIZE];

    segregate0and1(arr, SIZE);
    
    assert( forall ( int x, int y ) :: ( 0 <= x && x < y && y < SIZE && arr[x] ) ==> ( arr[y] ) );
    assert( forall ( int x, int y ) :: ( 0 <= x && x < y && y < SIZE && (!arr[y]) ) ==> ( !arr[x] ) );
    
    return 0;
}
